// xDBSearch Package  1998, Deks
// Version info in readme.txt and help
//
// http://deks.webjump.com/
// E-mail: Deks@online.nsk.su
unit uxDBSearchForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, Menus, uxDBSearch;

type
  TxDBSearchForm = class(TForm)
    xTextToFind: TLabel;
    EditText: TEdit;
    EditCaseSensitive: TCheckBox;
    EditCompleteKey: TCheckBox;
    ButtonOK: TButton;
    CancelBtn: TButton;
    EditField: TComboBox;
    xSearchField: TLabel;
    DialogMenu: TPopupMenu;
    DialogCloseMI: TMenuItem;
    procedure ButtonOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DialogCloseMIClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    SearchFields: TList;
    FDBSearch: TxDBSearch;
    procedure SetDBSearch(Value: TxDBSearch);
  public
    SearchField: String;
    SearchText: String;
    SearchOptions: TLocateOptions;
    property DBSearch: TxDBSearch read FDBSearch write SetDBSearch;

    procedure InitControls;
  end;

var
  xDBSearchForm: TxDBSearchForm;

implementation

{$R *.DFM}

uses uxDBSearchConstants;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.SetDBSearch;
begin
  FDBSearch := Value;
  if FDBSearch <> nil then
    SearchFields := FDBSearch.DBSearchFields;
end;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.InitControls;
var
  i: Integer;
  aField: TxDBSearchField;
  aCaption: String;
begin
  //   "".

  //      :
  if SearchFields = nil then Exit;

  //    :
  EditField.Items.Clear;

  //      :
  for i := 0 to SearchFields.Count-1 do begin
    aField := TxDBSearchField(SearchFields[i]);
    if aField = nil then Continue;

    //    :
    if aField.FieldCaption = '' then begin
      //   TxDBSearchField.Field.DisplayName:
      if aField.Field <> nil then
        aCaption := aField.Field.DisplayName;
    end else
      //   TxDBSearchField.FieldCaption:
      aCaption := aField.FieldCaption;

    //    :
    EditField.Items.Add(aCaption);
  end;

  //      :
  if EditField.Items.Count >0 then
    EditField.ItemIndex := 0
  else
    EditField.ItemIndex := -1;
end;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.ButtonOKClick(Sender: TObject);
var
  i: Integer;
  aField: TxDBSearchField;
begin
  //    OK.

  //     :
  if SearchFields = nil then Exit;

  //   :
  SearchField := '';
  SearchText := '';
  SearchOptions := [];

  //    SearchField:
  for i := 0 to SearchFields.Count-1 do begin
   aField := TxDBSearchField(SearchFields[i]);
   if (aField <> nil)
   and (aField.Field <> nil)
   and ((aField.FieldCaption = EditField.Text) or (aField.Field.DisplayName = EditField.Text)) then begin
     SearchField := aField.Field.FieldName;
     SearchText := EditText.Text;
   end;
  end;

  //       SearchOptions:
  if EditCaseSensitive.Checked = False then
    SearchOptions := SearchOptions + [loCaseInsensitive];
  if EditCompleteKey.Checked = False then
    SearchOptions := SearchOptions + [loPartialKey];
end;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.FormShow(Sender: TObject);
begin
  //     .

  //    :
  ActiveControl := EditField;
end;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.DialogCloseMIClick(Sender: TObject);
begin
  //   .
  CancelBtn.Click;
end;

// ----------------------------------------------------------------------------
procedure TxDBSearchForm.FormCreate(Sender: TObject);
begin
  // Set locale-specific string resources.
  xSearchField.Caption := SxDBS_SearchField;
  xTextToFind.Caption := SxDBS_TextToFind;
  EditCaseSensitive.Caption := SxDBS_CaseSensitive;
  EditCompleteKey.Caption := SxDBS_ExactMatchOnly;
  ButtonOK.Caption := SxDBS_ButtonOK;
  CancelBtn.Caption := SxDBS_ButtonCancel;
end;

end.
